﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Charting;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            this.radChart1.ItemsSource = new int[] { 1, 2, 3 };
        }

        private static string HiddenState = "Hidden";
        private static string HoverState = "Hovered";
        private static string NormalState = "Normal";

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            HoverItem<Pie>(1);
            HoverItem<SeriesItemLabel>(1);
        }

        /// <summary>
        /// Hides all items but the item at the specified index.
        /// </summary>
        /// <typeparam name="T">The type of the item.</typeparam>
        /// <param name="index">The index of the item to hover.</param>
        private void HoverItem<T>(int index)
            where T : Control
        {
            var items = this.radChart1.ChildrenOfType<T>();
            var itemToHover = items.ElementAt(index);
            foreach (var item in items)
            {
                if (item == itemToHover)
                    continue;
                VisualStateManager.GoToState(item, HiddenState, true);
            }
        }
    }
}
